import * as faceapi from 'face-api.js';
import { TaskTypeToken } from '../tokens/TaskTypeToken';
import { FeatureToken } from '../tokens/FeatureToken';
export declare class DetectTask {
    readonly resolveTarget: (el: HTMLImageElement | HTMLVideoElement) => void;
    readonly type: TaskTypeToken;
    readonly tokens: FeatureToken[];
    readonly realtime: boolean;
    constructor(option: {
        type: TaskTypeToken;
        tokens: FeatureToken[];
        realtime?: boolean;
    });
    target: Promise<HTMLImageElement | HTMLVideoElement>;
    private targetResolver;
    private isMatchPattern;
    with(...tokens: FeatureToken[]): this;
    detect(option?: faceapi.FaceDetectionOptions): Promise<any>;
}
