import { OnInit, ElementRef, Renderer2, OnDestroy } from '@angular/core';
import { Subscription } from 'rxjs';
import { DetectTask } from '../../classes/DetectTask';
import { FaceDetectorService } from '../../services/face-detector.service';
export declare class DetectionResultComponent implements OnInit, OnDestroy {
    private task;
    private el;
    private renderer;
    private faceDetector;
    subscription: Subscription;
    private canvasEl;
    private readonly canvas;
    private resize$;
    onResize(): void;
    constructor(task: DetectTask, el: ElementRef, renderer: Renderer2, faceDetector: FaceDetectorService);
    private convertResultToArray;
    ngOnInit(): void;
    ngOnDestroy(): void;
    private draw;
}
