import * as faceapi from 'face-api.js';
import { Observable } from 'rxjs';
import { ModelLoaderService } from './model-loader.service';
import { DetectTask } from '../classes/DetectTask';
export declare class FaceDetectorService {
    private modelLoader;
    private option?;
    constructor(modelLoader: ModelLoaderService, option?: faceapi.FaceDetectionOptions);
    detect(task: DetectTask): Observable<any>;
}
