import { ElementRef, Injector, OnInit } from '@angular/core';
import { Overlay } from '@angular/cdk/overlay';
import { TaskTypeToken } from '../tokens/TaskTypeToken';
import { FeatureToken } from '../tokens/FeatureToken';
import { AbstractDetectDirective } from './abbstract-detect.directive';
export declare class DetectSingleFaceImgDirective extends AbstractDetectDirective implements OnInit {
    with: FeatureToken[];
    constructor(el: ElementRef<HTMLImageElement>, overlay: Overlay, injector: Injector);
    protected type: TaskTypeToken;
    protected stream: boolean;
    ngOnInit(): void;
}
