import { FeatureToken } from '../tokens/FeatureToken';
import { ModelToken } from '../tokens/ModelToken';
export declare class ModelLoaderService {
    private modelUrl;
    private loadedModels;
    constructor(modelUrl: string);
    private getReqiredModels;
    private mapLoadFunction;
    isLoaded(model: ModelToken): boolean;
    load(...models: ModelToken[]): Promise<void>;
    loadForFeature(tokens: FeatureToken[]): Promise<void>;
}
